#include <iostream>

#define MAX_TABLE_LENGTH 250

class CEvalExpression
{
public:
	CEvalExpression();
	~CEvalExpression();

	double Eval(char *Expression);
	void SetVariable(char* Name,double Value);

private:
	char* Expression;
	int ExpressionLength;
	int Index;

	double Func1();
	double Func2();
	double Func3();
	double Func4();
	double Func5();
	double Func6();

	// ee[uւ̓o^
	void SetTables(char* Name,char** Tables,int* Count);

	// 萔e[u
	double Const(char* Name);
	int ConstCount;
	char* ConstTable[MAX_TABLE_LENGTH];

	// ϐe[u
	double Variable(char* Name);
	int VariableCount;
	char* VariableTable[MAX_TABLE_LENGTH];
	double VariableValue[MAX_TABLE_LENGTH];

	// ֐e[u
	double Function(char* Name);
	int FunctionCount;
	char* FunctionTable[MAX_TABLE_LENGTH];

	// e[u̒gɑ݂邩̃`FbN
	bool TableCheck(char* Name,char** Table,int ArrayLength);

	// ̕
	void SplitArguments(char* Dest,char* Src,int Number);

	void Trim(char* Dest,char* Src);

	void CopyVariable(CEvalExpression* Dest);
	double EvalAnotherExpression(char *Expression);
	int GetEndArgumentsLength(char* str);
};
